<?php

namespace Chemical\Pricelist\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class PricelistTransformer extends TransformerAbstract
{
    public function transform(\Chemical\Pricelist\Models\Pricelist $pricelist)
    {
        return [
            'id'                => $pricelist->getRouteKey(),
            'key'               => [
                'public'    => $pricelist->getPublicKey(),
                'route'     => $pricelist->getRouteKey(),
            ], 
            'id'                => $pricelist->id,
            'slug'              => $pricelist->slug,
            'name'              => $pricelist->name,
            'status'            => $pricelist->status,
            'order'             => $pricelist->order,
            'price'             => $pricelist->price,
            'details'           => $pricelist->details,
            'created_at'        => $pricelist->created_at,
            'updated_at'        => $pricelist->updated_at,
            'deleted_at'        => $pricelist->deleted_at,
            'url'               => [
                'public'    => trans_url('pricelist/'.$pricelist->getPublicKey()),
                'user'      => guard_url('pricelist/pricelist/'.$pricelist->getRouteKey()),
            ], 
            'status'            => trans('app.'.$pricelist->status),
            'created_at'        => format_date($pricelist->created_at),
            'updated_at'        => format_date($pricelist->updated_at),
        ];
    }
}